/// <reference types="node" />
import { Readable } from "stream";
import { AjaxError, JsonWebToken } from "@snickerdoodlelabs/objects";
import { AxiosInstance } from "axios";
import { ResultAsync } from "neverthrow";
import { IAxiosAjaxUtils, IRequestConfig } from "../interfaces/index.js";
export declare class AxiosAjaxUtils implements IAxiosAjaxUtils {
    protected instance: AxiosInstance;
    constructor();
    get<T>(url: URL, config?: IRequestConfig): ResultAsync<T, AjaxError>;
    post<T>(url: URL, data: string | Record<string, unknown> | ArrayBuffer | ArrayBufferView | Readable | URLSearchParams, config?: IRequestConfig): ResultAsync<T, AjaxError>;
    put<T>(url: URL, data: string | Record<string, unknown> | ArrayBuffer | ArrayBufferView | Readable | URLSearchParams, config?: IRequestConfig): ResultAsync<T, AjaxError>;
    delete<T>(url: URL, config?: IRequestConfig): ResultAsync<T, AjaxError>;
    setDefaultToken(token: JsonWebToken): void;
}
//# sourceMappingURL=AxiosAjaxUtils.d.ts.map