var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { AjaxError } from "@snickerdoodlelabs/objects";
import axios from "axios";
import { injectable } from "inversify";
import { ResultAsync } from "neverthrow";
import fetchAdapter from "../implementations/FetchAdapter.js";
let AxiosAjaxUtils = class AxiosAjaxUtils {
    constructor() {
        // Browsers have XMLHttpRequest, node has the http object. Axios will use
        // the right one depending. But server workers have neither, and need to
        // use the fetch adapter.
        // These checks are a PITA
        if (typeof importScripts === "function") {
            this.instance = axios.create({
                adapter: fetchAdapter,
            });
        }
        else {
            this.instance = axios.create({});
        }
    }
    get(url, config) {
        return ResultAsync.fromPromise(this.instance.get(url.toString(), config), (e) => new AjaxError(`Unable to get ${url}`, e)).map((response) => {
            return response.data;
        });
    }
    post(url, data, config) {
        return ResultAsync.fromPromise(this.instance.post(url.toString(), data, config), (e) => new AjaxError(`Unable to post ${url}`, e)).map((response) => {
            return response.data;
        });
    }
    put(url, data, config) {
        return ResultAsync.fromPromise(this.instance.put(url.toString(), data, config), (e) => new AjaxError(`Unable to put ${url}`, e)).map((response) => {
            return response.data;
        });
    }
    delete(url, config) {
        return ResultAsync.fromPromise(this.instance.delete(url.toString(), config), (e) => new AjaxError(`Unable to delete ${url}`, e)).map((response) => {
            return response.data;
        });
    }
    setDefaultToken(token) {
        this.instance.defaults.headers.common = {
            authorization: `Bearer ${token}`,
        };
    }
};
AxiosAjaxUtils = __decorate([
    injectable()
], AxiosAjaxUtils);
export { AxiosAjaxUtils };
//# sourceMappingURL=AxiosAjaxUtils.js.map